(defun read-file-contents (file)
  (read (with-temp-buffer
               (insert-file-contents file)
               (buffer-string))))

(use-package guix-profiles
  :init (progn
          (defvar guix-home-dir "/home/pino")
          (defvar guix-manifest-prefix (format "%s/data/config/manifests" guix-home-dir))
          (defvar guix-profile-prefix (format "%s/profiles" guix-home-dir)))
  :config (progn
            (setq guix-available-profiles
                  (mapcar (lambda (profile-name)
                            (cons profile-name (list :profile-file (format "%s/%s/%s"
                                                                           guix-profile-prefix
                                                                           profile-name
                                                                           profile-name)
                                                     :manifest-file (format "%s/%s.scm"
                                                                            guix-manifest-prefix
                                                                            profile-name))))
                          (append (read-file-contents (format "%s/optional.scm" guix-manifest-prefix))
                                  (read-file-contents (format "%s/core.scm" guix-manifest-prefix)))))
            (setq guix-active-profiles (read-file-contents (format "%s/core.scm" guix-manifest-prefix)))
            (guix-set-paths guix-active-profiles)))

(provide 'init-profiles)
